#!/usr/bin/env python
"""
Copyright 2014-2015 Taxamo, Ltd.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""
class Input_transaction_line:
    """NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually."""


    def __init__(self):
        self.swaggerTypes = {
            'product_type': 'str',
            'supply_date': 'str',
            'unit_price': 'number',
            'unit_of_measure': 'str',
            'quantity': 'number',
            'custom_fields': 'list[custom_fields]',
            'line_key': 'str',
            'tax_name': 'str',
            'product_code': 'str',
            'amount': 'number',
            'custom_id': 'str',
            'informative': 'bool',
            'tax_rate': 'number',
            'total_amount': 'number',
            'description': 'str'

        }


        #Product type, according to dictionary /dictionaries/product_types. 
        self.product_type = None # str
        #Date of supply in yyyy-MM-dd format.
        self.supply_date = None # str
        #Unit price.
        self.unit_price = None # number
        #Unit of measure.
        self.unit_of_measure = None # str
        #Quantity Defaults to 1.
        self.quantity = None # number
        #Custom fields, stored as key-value pairs. This property is not processed and used mostly with Taxamo-built helpers.
        self.custom_fields = None # list[custom_fields]
        #Generated line key.
        self.line_key = None # str
        #Tax name, calculated by taxamo.  Can be overwritten when informative field is true.
        self.tax_name = None # str
        #Internal product code, used for invoicing for example.
        self.product_code = None # str
        #Amount. Required if total amount is not provided.
        self.amount = None # number
        #Custom id, provided by ecommerce software.
        self.custom_id = None # str
        #If the line is provided for informative purposes. Such line must have :tax-rate and optionally :tax-name - if not, API validation will fail for this line.
        self.informative = None # bool
        #Tax rate, calculated by taxamo. Must be provided when informative field is true.
        self.tax_rate = None # number
        #Total amount. Required if amount is not provided.
        self.total_amount = None # number
        #Line contents description.
        self.description = None # str
        
